//###########################################################################
//# ftpbnc 0.21 by comrade
//# comrade2k@hotmail.com
//# http://comrade64.cjb.net/
//###########################################################################
//###########################################################################
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
//###########################################################################
typedef struct {
	int  lsock;
	int  rsock;
	char status;
} CONN;
//###########################################################################
#define max(a, b)  ((a) > (b) ? (a) : (b))
#define min(a, b)  ((a) < (b) ? (a) : (b))
#define DATA_SIZE 8192
#define MAX_SOCKETS 128
#define LOG_LEVEL 0
//###########################################################################
CONN conns[MAX_SOCKETS];
int lsock, csock, rsock, sockets=0;
char *local, *remote;
char *welcome   = "220 [ftpbnc 0.21 by comrade] ready\x0D\x0A";
char *passwdreq = "331 Password required.\x0D\x0A";
char *loggedin  = "230 User logged in.\x0D\x0A";
char *loginbad  = "530 Login incorrect.\x0D\x0A";
//char *badcmd    = "530 Bad command.\x0D\x0A";
//###########################################################################
int main(int, char**);
void log(unsigned int, const char*, ...);
void remove_conn(unsigned int);
void freeres();
void quit(const char*);
void sigterm(int);
//###########################################################################
//###########################################################################
//###########################################################################
//###########################################################################
int main(int argc, char **argv){
	FILE* hFile; unsigned char pid[16]; char *lhost, *rhost, *lport, *rport;
	struct sockaddr_in lsin, sin; struct hostent *hp; fd_set fds; struct timeval tv;
	unsigned int localb, remoteb, i, k;

	log(0, "  ftpbnc 0.21 by comrade\n  comrade2k@hotmail.com\n  http://comrade64.cjb.net/");
	if (argc != 5){
		log(0, "Usage: ftpbnc listenhost listenport username password");
		return 0;
	}
	//signal(SIGHUP, SIG_IGN);
	signal(SIGTERM, sigterm);
	signal(SIGPIPE, SIG_IGN);
	if (fork()) return 0;	// parent
	lhost = argv[1];
	lport = argv[2];
	*(lport-1)=0;

	memset(&conns, 0, sizeof(conns));

	hFile = fopen("ftpbnc.pid", "wb");
	fwrite(&pid, sprintf(pid, "%lu\n", getpid()), 1, hFile);
	fclose(hFile);
	log(0, "\nSuccessfully loaded into background (PID %lu)...", getpid());
	if ((lsock = socket(AF_INET, SOCK_STREAM, 0)) == -1) quit("Failed to create socket!");
	log(1, "lsock = %08X", lsock);
	//fcntl(lsock, F_SETFL, O_NONBLOCK);
	i = 1;
	if (setsockopt(lsock, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(i))) quit("Failed to set socket options!");
	lsin.sin_family = AF_INET; lsin.sin_port = htons(atoi(lport));
	if ((lsin.sin_addr.s_addr = inet_addr(lhost)) == INADDR_NONE){
		if (!(hp = gethostbyname(lhost))) quit("Invalid listen hostname!");
		memcpy(&lsin.sin_addr, hp->h_addr, hp->h_length);
	}
	if (bind(lsock, (struct sockaddr*)&lsin, sizeof(lsin))) quit("Failed to bind socket!");
	if (listen(lsock, 5)) quit("Failed to listen on socket!");
	remote = malloc(DATA_SIZE);
	local = malloc(DATA_SIZE);
	while(1){
		// accept new connections
		FD_ZERO(&fds);
		FD_SET(lsock, &fds);
		tv.tv_sec = 0; tv.tv_usec = 250;
		if (select(lsock+1, &fds, 0, 0, &tv)){
			if (FD_ISSET(lsock, &fds)){
				csock = accept(lsock, 0, 0);
				log(1, "csock = %08X", csock);
				if ((csock) > 0){
					log(1, "New connection");
					fcntl(csock, F_SETFL, O_NONBLOCK);
					conns[sockets  ].lsock = csock;
					conns[sockets++].rsock = 0;
					send(csock, welcome, strlen(welcome), 0);
				}
			}
		}
		// bounce data
		for(i = 0; i < sockets; i++){
			memset( local, 0, DATA_SIZE);
			memset(remote, 0, DATA_SIZE);
			if      ((conns[i].lsock) && !( localb = recv(conns[i].lsock,  local, DATA_SIZE, 0))) {
				log(1, "Local socket died");
				remove_conn(i);
			}
			else if ((conns[i].rsock) && !(remoteb = recv(conns[i].rsock, remote, DATA_SIZE, 0))) {
				log(1, "Remote socket died");
				remove_conn(i);
			}
			else {
				if (( localb <= DATA_SIZE) &&  localb) log(1, "Got  local data: %s", local);
				if ((remoteb <= DATA_SIZE) && remoteb) log(1, "Got remote data: %s", remote);
				if (conns[i].lsock && !conns[i].rsock && localb && (localb <= DATA_SIZE)){	// not connected yet
					local[localb-2] = 0;
					log(2, "Received: %s", local);
					if ((conns[i].status==0) && (!strncasecmp(local, "user", 4))){		// check for username
						log(1, "Checking username...");
						if (!strcmp(argv[3], local+5)){
							memcpy(remote, passwdreq, strlen(passwdreq));
							conns[i].status++;
						} else memcpy(remote, loginbad, strlen(loginbad));
						remoteb = strlen(remote);
						localb = 0;
					} else if ((conns[i].status==1) && (!strncasecmp(local, "pass", 4))) {	// check for password
						log(1, "Checking password...");
						if (!strcmp(argv[4], local+5)){
						memcpy(remote, loggedin, strlen(loggedin));
							conns[i].status++;
						} else {
							memcpy(remote, loginbad, strlen(loginbad));
							conns[i].status--;
						}
						remoteb = strlen(remote);
						localb = 0;
					} else if ((conns[i].status==2) && ((!strncasecmp(local, "open", 4)) || (!strncasecmp(local, "site", 4)))) {	// check for host:port
						log(1, "Bouncing...");
						rhost = &local[5];
						if (!(rport = strchr(rhost, ':'))) rport = strchr(rhost, ' ');
						sin.sin_family = AF_INET;
						if (rport){
							*rport++=0;
							sin.sin_port = htons(atoi(rport));
						}
						else sin.sin_port = htons(21);
						log(1, "Connecting to %s:%u...", rhost, ntohs(sin.sin_port));

						rsock = socket(AF_INET, SOCK_STREAM, 0);
						log(1, "rsock = %08X", rsock);
						fcntl(rsock, F_SETFL, O_NONBLOCK);
						lsin.sin_port = 0;
						bind(rsock, (struct sockaddr*)&lsin, sizeof(lsin));
						if ((sin.sin_addr.s_addr = inet_addr(rhost)) == INADDR_NONE){
							if (!(hp = gethostbyname(rhost))) break;
							memcpy(&sin.sin_addr, hp->h_addr, hp->h_length);
						}
						if ((!connect(rsock, (struct sockaddr*)&sin, sizeof(sin))) || (errno==EINPROGRESS)){
							log(1, "Connected!");
							conns[i].rsock = rsock;
							conns[i].status++;
						} else remove_conn(i);
						localb = 0; remoteb = 0;
					} else {
						//log(1, "Bad command");
						//memcpy(remote, &badcmd, sizeof(badcmd));
						//remoteb = strlen(remote);
						localb = 0; remoteb = 0;
						remove_conn(i);
					}
				}
				if (( localb <= DATA_SIZE) &&  localb && conns[i].rsock){
					log(2, "Send to REMOTE: %s (%lu bytes)", local, localb);
					
					k = send(conns[i].rsock,  local,  localb, 0);
					log(2, "Sent %u bytes!", k);
					localb = 0;
				}
				if ((remoteb <= DATA_SIZE) && remoteb && conns[i].lsock){
					log(2, "Send to  LOCAL: %s (%lu bytes)", remote, remoteb);
					k = send(conns[i].lsock, remote, remoteb, 0);
					log(2, "Sent %u bytes!", k);
					remoteb = 0;
				}
			}
		}
	}
	return 0;
}
//###########################################################################
void log(unsigned int level, const char *format, ...){
	va_list args;
	if (level>LOG_LEVEL) return;
	va_start(args, format);
	vprintf(format, args);
	va_end(args);
	puts("");
	fflush(stdout);
	return;
}
//###########################################################################
void remove_conn(unsigned int index){
	log(1, "Removing connection %u\n=========================", index);
	//shutdown(conns[index].lsock, 2); shutdown(conns[index].rsock, 2);
	if (conns[index].lsock) close(conns[index].lsock);
	if (conns[index].rsock) close(conns[index].rsock);
	memcpy(&conns[index], &conns[index+1], (MAX_SOCKETS-index-1)*sizeof(CONN));
	sockets--;
}
//###########################################################################
void freeres(){
	int i=0;
	for(i; i < sockets; i++){
		//shutdown(conns[i].lsock, 2); shutdown(conns[i].rsock, 2);
		close(conns[i].lsock); close(conns[i].rsock);
	}
	close(rsock); close(csock); close(lsock);
	free(local);
	free(remote);
}
//###########################################################################
void quit(const char* error){ freeres(); log(0, "Quitting: %s", error); exit(0); }
//###########################################################################
void sigterm(int sig){ freeres(); exit(0); }
//###########################################################################
//###########################################################################
